Imports DesktopSerialIO
Imports System.Text
Public Class Form1
    Inherits System.Windows.Forms.Form

    Private WithEvents SerialPort As New DesktopSerialIO.SerialIO.SerialPort
    Private ReceiveBuffer As New StringBuilder(32768)

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents TextBox1 As System.Windows.Forms.TextBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.TextBox1 = New System.Windows.Forms.TextBox
        Me.SuspendLayout()
        '
        'TextBox1
        '
        Me.TextBox1.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.TextBox1.Location = New System.Drawing.Point(0, 0)
        Me.TextBox1.Multiline = True
        Me.TextBox1.Name = "TextBox1"
        Me.TextBox1.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.TextBox1.Size = New System.Drawing.Size(296, 264)
        Me.TextBox1.TabIndex = 0
        Me.TextBox1.Text = ""
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(292, 266)
        Me.Controls.Add(Me.TextBox1)
        Me.Name = "Form1"
        Me.Text = "Simple Terminal"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        With SerialPort
            Try
                .CommPort = 7
            Catch ex As Exception
                MsgBox("Unable to assign commport", MsgBoxStyle.Critical)
            End Try
            .BitRate = 9600
            .RTSEnable = True
            .DTREnable = True
            .EnableOnComm = True
            .PortOpen = True
            If .PortOpen = False Then MsgBox("Unable to open serial port")
        End With
    End Sub

    Private Sub Form1_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        With SerialPort
            If .PortOpen = True Then .PortOpen = False
        End With
    End Sub

    Private Sub TextBox1_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox1.KeyPress
        With SerialPort
            If .PortOpen Then
                .Output(e.KeyChar)
            End If
        End With
        e.Handled = True
    End Sub

    Private Sub SerialPort_OnComm() Handles SerialPort.OnComm
        ReceiveBuffer.Append(SerialPort.InputString)
        Debug.WriteLine(ReceiveBuffer.ToString)
        Me.BeginInvoke(New EventHandler(AddressOf DisplayData))
    End Sub

    Private Sub DisplayData(ByVal sender As Object, ByVal e As EventArgs)
        'This marshalls receive data from the receive thread context (OnComm or CommError) to the Windows Form STAThread context
        With TextBox1
            .Text = ReceiveBuffer.ToString
            .SelectionStart = .Text.Length
        End With
        With ReceiveBuffer
            If .Length > 0.8 * .Capacity Then
                ReceiveBuffer.Remove(0, CInt(0.6 * .Capacity))
            End If
        End With
    End Sub
End Class
